summaryrefslogtreecommitdiff
path: root/src/share/common
blob: b26b57e2a42bc5be6ca3c1fe93f3d9e32f5ce86d (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$*"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$*"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local lines
  286. local tempfile
  287. file="$1"
  288. shift
  289. if [ ! -e "$file" ] ; then
  290. return 1
  291. fi
  292. if (($# == 1)) ; then
  293. lines=$(grep -F "$1" "$file") || true
  294. else
  295. lines=$(grep -F "$1" "$file" | grep -F "$2") || true
  296. fi
  297. # if the string was found, remove it
  298. if [ "$lines" ] ; then
  299. log debug "removing matching key lines..."
  300. tempfile=$(mktemp "${file}.XXXXXXX") || \
  301. failure "Unable to make temp file '${file}.XXXXXXX'"
  302. grep -v -x -F "$lines" "$file" >"$tempfile"
  303. mv -f "$tempfile" "$file"
  304. fi
  305. }
  306. # remove all lines with MonkeySphere strings from stdin
  307. remove_monkeysphere_lines() {
  308. egrep -v ' MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2} '
  309. }
  310. # translate ssh-style path variables %h and %u
  311. translate_ssh_variables() {
  312. local uname
  313. local home
  314. uname="$1"
  315. path="$2"
  316. # get the user's home directory
  317. userHome=$(get_homedir "$uname")
  318. # translate '%u' to user name
  319. path=${path/\%u/"$uname"}
  320. # translate '%h' to user home directory
  321. path=${path/\%h/"$userHome"}
  322. echo "$path"
  323. }
  324. # test that a string to conforms to GPG's expiration format
  325. test_gpg_expire() {
  326. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  327. }
  328. # touch a key file if it doesn't exist, including creating needed
  329. # directories with correct permissions
  330. touch_key_file_or_fail() {
  331. local keyFile="$1"
  332. local newUmask
  333. if [ ! -f "$keyFile" ]; then
  334. # make sure to create files and directories with the
  335. # appropriate write bits turned off:
  336. newUmask=$(printf "%04o" $(( 0$(umask) | 0022 )) )
  337. [ -d $(dirname "$keyFile") ] \
  338. || (umask "$newUmask" && mkdir -p -m 0700 $(dirname "$keyFile") ) \
  339. || failure "Could not create path to $keyFile"
  340. # make sure to create this file with the appropriate bits turned off:
  341. (umask "$newUmask" && touch "$keyFile") \
  342. || failure "Unable to create $keyFile"
  343. fi
  344. }
  345. # check that a file is properly owned, and that all it's parent
  346. # directories are not group/other writable
  347. check_key_file_permissions() {
  348. local uname
  349. local path
  350. uname="$1"
  351. path="$2"
  352. if [ "$STRICT_MODES" = 'false' ] ; then
  353. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  354. return 0
  355. fi
  356. log debug "checking path permission '$path'..."
  357. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  358. }
  359. # return a list of all users on the system
  360. list_users() {
  361. if type getent &>/dev/null ; then
  362. # for linux and FreeBSD systems
  363. getent passwd | cut -d: -f1
  364. elif type dscl &>/dev/null ; then
  365. # for Darwin systems
  366. dscl localhost -list /Search/Users
  367. else
  368. failure "Neither getent or dscl is in the path! Could not determine list of users."
  369. fi
  370. }
  371. # take one argument, a service name. in response, print a series of
  372. # lines, each with a unique numeric port number that might be
  373. # associated with that service name. (e.g. in: "https", out: "443")
  374. # if nothing is found, print nothing, and return 0.
  375. #
  376. # return 1 if there was an error in the search somehow
  377. get_port_for_service() {
  378. [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
  379. failure $(printf "This is not a valid service name: '%s'" "$1")
  380. if type getent &>/dev/null ; then
  381. # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
  382. (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
  383. elif [ -r /etc/services ] ; then
  384. # fall back to /etc/services for systems that don't have getent (MacOS?)
  385. # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
  386. awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
  387. else
  388. return 1
  389. fi
  390. }
  391. # return the path to the home directory of a user
  392. get_homedir() {
  393. local uname=${1:-`whoami`}
  394. eval "echo ~${uname}"
  395. }
  396. # return the primary group of a user
  397. get_primary_group() {
  398. local uname=${1:-`whoami`}
  399. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  400. }
  401. ### CONVERSION UTILITIES
  402. # output the ssh key for a given key ID
  403. gpg2ssh() {
  404. local keyID
  405. keyID="$1"
  406. gpg --export --no-armor "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  407. }
  408. # output known_hosts line from ssh key
  409. ssh2known_hosts() {
  410. local host
  411. local port
  412. local key
  413. # FIXME this does not properly deal with IPv6 hosts using the
  414. # standard port (because it's unclear whether their final
  415. # colon-delimited address section is a port number or an address
  416. # string)
  417. host=${1%:*}
  418. port=${1##*:}
  419. key="$2"
  420. # specify the host and port properly for new ssh known_hosts
  421. # format
  422. if [ "$port" != "$host" ] ; then
  423. host="[${host}]:${port}"
  424. fi
  425. # hash if specified
  426. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  427. if (type ssh-keygen >/dev/null) ; then
  428. log verbose "hashing known_hosts line"
  429. # FIXME: this is really hackish cause
  430. # ssh-keygen won't hash from stdin to
  431. # stdout
  432. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  433. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE" \
  434. > "$tmpfile"
  435. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  436. if [[ "$keyFile" == '-' ]] ; then
  437. cat "$tmpfile"
  438. else
  439. cat "$tmpfile" >> "$keyFile"
  440. fi
  441. rm -f "$tmpfile" "${tmpfile}.old"
  442. # FIXME: we could do this without needing ssh-keygen.
  443. # hashed known_hosts looks like: |1|X|Y where 1 means SHA1
  444. # (nothing else is defined in openssh sources), X is the
  445. # salt (same length as the digest output), base64-encoded,
  446. # and Y is the digested hostname (also base64-encoded).
  447. # see hostfile.{c,h} in openssh sources.
  448. else
  449. log error "Cannot hash known_hosts line as requested."
  450. fi
  451. else
  452. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  453. fi
  454. }
  455. # output authorized_keys line from ssh key
  456. ssh2authorized_keys() {
  457. local userID="$1"
  458. local key="$2"
  459. if [[ "$AUTHORIZED_KEYS_OPTIONS" ]]; then
  460. printf "%s %s MonkeySphere%s %s\n" "$AUTHORIZED_KEYS_OPTIONS" "$key" "$DATE" "$userID"
  461. else
  462. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  463. fi
  464. }
  465. # convert key from gpg to ssh known_hosts format
  466. gpg2known_hosts() {
  467. local host
  468. local keyID
  469. local key
  470. host="$1"
  471. keyID="$2"
  472. key=$(gpg2ssh "$keyID")
  473. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  474. # all lines in the known_hosts file. why?
  475. # NOTE: just in case, the COMMENT can be matched with the
  476. # following regexp:
  477. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  478. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  479. }
  480. # convert key from gpg to ssh authorized_keys format
  481. gpg2authorized_keys() {
  482. local userID
  483. local keyID
  484. local key
  485. userID="$1"
  486. keyID="$2"
  487. key=$(gpg2ssh "$keyID")
  488. # NOTE: just in case, the COMMENT can be matched with the
  489. # following regexp:
  490. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  491. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  492. }
  493. ### GPG UTILITIES
  494. # script to determine if gpg version is equal to or greater than specified version
  495. is_gpg_version_greater_equal() {
  496. local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
  497. local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
  498. | tr '.' ' ' | sort -g -k1 -k2 -k3 \
  499. | tail -1 | tr ' ' '.')
  500. [[ "$gpgVersion" == "$latest" ]]
  501. }
  502. # retrieve all keys with given user id from keyserver
  503. # FIXME: need to figure out how to retrieve all matching keys
  504. # (not just first N (5 in this case))
  505. gpg_fetch_userid() {
  506. local returnCode=0
  507. local userID
  508. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  509. return 0
  510. fi
  511. userID="$1"
  512. log verbose " checking keyserver $KEYSERVER... "
  513. echo 1,2,3,4,5 | \
  514. gpg --quiet --batch --with-colons \
  515. --command-fd 0 --keyserver "$KEYSERVER" \
  516. --search ="$userID" &>/dev/null
  517. returnCode="$?"
  518. if [ "$returnCode" != 0 ] ; then
  519. log error "Failure ($returnCode) searching keyserver $KEYSERVER for user id '$userID'"
  520. fi
  521. return "$returnCode"
  522. }
  523. ########################################################################
  524. ### PROCESSING FUNCTIONS
  525. # userid and key policy checking
  526. # the following checks policy on the returned keys
  527. # - checks that full key has appropriate valididy (u|f)
  528. # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
  529. # - checks that requested user ID has appropriate validity
  530. # (see /usr/share/doc/gnupg/DETAILS.gz)
  531. # output is one line for every found key, in the following format:
  532. #
  533. # flag:sshKey
  534. #
  535. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  536. # "sshKey" is the relevant OpenPGP key, in the form accepted by OpenSSH
  537. #
  538. # all log output must go to stderr, as stdout is used to pass the
  539. # flag:sshKey to the calling function.
  540. process_user_id() {
  541. local returnCode=0
  542. local userID="$1"
  543. local requiredCapability
  544. local requiredPubCapability
  545. local gpgOut
  546. local type
  547. local validity
  548. local keyid
  549. local uidfpr
  550. local usage
  551. local keyOK
  552. local uidOK
  553. local lastKey
  554. local lastKeyOK
  555. local fingerprint
  556. # set the required key capability based on the mode
  557. requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
  558. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  559. # fetch the user ID if necessary/requested
  560. gpg_fetch_userid "$userID"
  561. # output gpg info for (exact) userid and store
  562. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  563. --with-fingerprint --with-fingerprint \
  564. ="$userID" 2>/dev/null) || returnCode="$?"
  565. # if the gpg query return code is not 0, return 1
  566. if [ "$returnCode" -ne 0 ] ; then
  567. log verbose " no primary keys found."
  568. return 1
  569. fi
  570. # loop over all lines in the gpg output and process.
  571. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  572. while IFS=: read -r type validity keyid uidfpr usage ; do
  573. # process based on record type
  574. case $type in
  575. 'pub') # primary keys
  576. # new key, wipe the slate
  577. keyOK=
  578. uidOK=
  579. lastKey=pub
  580. lastKeyOK=
  581. fingerprint=
  582. log verbose " primary key found: $keyid"
  583. # if overall key is not valid, skip
  584. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  585. log debug " - unacceptable primary key validity ($validity)."
  586. continue
  587. fi
  588. # if overall key is disabled, skip
  589. if check_capability "$usage" 'D' ; then
  590. log debug " - key disabled."
  591. continue
  592. fi
  593. # if overall key capability is not ok, skip
  594. if ! check_capability "$usage" $requiredPubCapability ; then
  595. log debug " - unacceptable primary key capability ($usage)."
  596. continue
  597. fi
  598. # mark overall key as ok
  599. keyOK=true
  600. # mark primary key as ok if capability is ok
  601. if check_capability "$usage" $requiredCapability ; then
  602. lastKeyOK=true
  603. fi
  604. ;;
  605. 'uid') # user ids
  606. if [ "$lastKey" != pub ] ; then
  607. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  608. continue
  609. fi
  610. # if an acceptable user ID was already found, skip
  611. if [ "$uidOK" = 'true' ] ; then
  612. continue
  613. fi
  614. # if the user ID does matches...
  615. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  616. # and the user ID validity is ok
  617. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  618. # mark user ID acceptable
  619. uidOK=true
  620. else
  621. log debug " - unacceptable user ID validity ($validity)."
  622. fi
  623. else
  624. continue
  625. fi
  626. # output a line for the primary key
  627. # 0 = ok, 1 = bad
  628. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  629. log verbose " * acceptable primary key."
  630. if [ -z "$sshKey" ] ; then
  631. log verbose " ! primary key could not be translated (not RSA?)."
  632. else
  633. echo "0:${sshKey}"
  634. fi
  635. else
  636. log debug " - unacceptable primary key."
  637. if [ -z "$sshKey" ] ; then
  638. log debug " ! primary key could not be translated (not RSA?)."
  639. else
  640. echo "1:${sshKey}"
  641. fi
  642. fi
  643. ;;
  644. 'sub') # sub keys
  645. # unset acceptability of last key
  646. lastKey=sub
  647. lastKeyOK=
  648. fingerprint=
  649. # don't bother with sub keys if the primary key is not valid
  650. if [ "$keyOK" != true ] ; then
  651. continue
  652. fi
  653. # don't bother with sub keys if no user ID is acceptable:
  654. if [ "$uidOK" != true ] ; then
  655. continue
  656. fi
  657. # if sub key validity is not ok, skip
  658. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  659. log debug " - unacceptable sub key validity ($validity)."
  660. continue
  661. fi
  662. # if sub key capability is not ok, skip
  663. if ! check_capability "$usage" $requiredCapability ; then
  664. log debug " - unacceptable sub key capability ($usage)."
  665. continue
  666. fi
  667. # mark sub key as ok
  668. lastKeyOK=true
  669. ;;
  670. 'fpr') # key fingerprint
  671. fingerprint="$uidfpr"
  672. sshKey=$(gpg2ssh "$fingerprint")
  673. # if the last key was the pub key, skip
  674. if [ "$lastKey" = pub ] ; then
  675. continue
  676. fi
  677. # output a line for the sub key
  678. # 0 = ok, 1 = bad
  679. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  680. log verbose " * acceptable sub key."
  681. if [ -z "$sshKey" ] ; then
  682. log error " ! sub key could not be translated (not RSA?)."
  683. else
  684. echo "0:${sshKey}"
  685. fi
  686. else
  687. log debug " - unacceptable sub key."
  688. if [ -z "$sshKey" ] ; then
  689. log debug " ! sub key could not be translated (not RSA?)."
  690. else
  691. echo "1:${sshKey}"
  692. fi
  693. fi
  694. ;;
  695. esac
  696. done | sort -t: -k1 -n -r
  697. # NOTE: this last sort is important so that the "good" keys (key
  698. # flag '0') come last. This is so that they take precedence when
  699. # being processed in the key files over "bad" keys (key flag '1')
  700. }
  701. process_keys_for_file() {
  702. local keyFile="$1"
  703. local userID="$2"
  704. local host
  705. local ok
  706. local sshKey
  707. local keyLine
  708. log verbose "processing: $userID"
  709. log debug "key file: $keyFile"
  710. IFS=$'\n'
  711. for line in $(process_user_id "$userID") ; do
  712. ok=${line%%:*}
  713. sshKey=${line#*:}
  714. if [ -z "$sshKey" ] ; then
  715. continue
  716. fi
  717. # remove the old key line
  718. if [[ "$keyFile" != '-' ]] ; then
  719. case "$FILE_TYPE" in
  720. ('authorized_keys')
  721. remove_line "$keyFile" "$sshKey"
  722. ;;
  723. ('known_hosts')
  724. host=${userID#ssh://}
  725. remove_line "$keyFile" "$host" "$sshKey"
  726. ;;
  727. esac
  728. fi
  729. # if key OK, add new key line
  730. if [ "$ok" -eq '0' ] ; then
  731. case "$FILE_TYPE" in
  732. ('raw')
  733. keyLine="$sshKey"
  734. ;;
  735. ('authorized_keys')
  736. keyLine=$(ssh2authorized_keys "$userID" "$sshKey")
  737. ;;
  738. ('known_hosts')
  739. host=${userID#ssh://}
  740. keyLine=$(ssh2known_hosts "$host" "$sshKey")
  741. ;;
  742. esac
  743. echo "$keyLine" | log debug
  744. if [[ "$keyFile" == '-' ]] ; then
  745. echo "$keyLine"
  746. else
  747. echo "$keyLine" >>"$keyFile"
  748. fi
  749. fi
  750. done
  751. }
  752. # process an authorized_user_ids file on stdin for authorized_keys
  753. process_authorized_user_ids() {
  754. local authorizedKeys="$1"
  755. declare -i nline=0
  756. local line
  757. declare -a userIDs
  758. declare -a koptions
  759. # extract user IDs from authorized_user_ids file
  760. IFS=$'\n'
  761. while read line ; do
  762. case "$line" in
  763. ("#"*)
  764. continue
  765. ;;
  766. (" "*|$'\t'*)
  767. if [[ -z ${koptions[${nline}]} ]]; then
  768. koptions[${nline}]=$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')
  769. else
  770. koptions[${nline}]="${koptions[${nline}]},$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')"
  771. fi
  772. ;;
  773. (*)
  774. ((++nline))
  775. userIDs[${nline}]="$line"
  776. unset koptions[${nline}] || true
  777. ;;
  778. esac
  779. done
  780. for i in $(seq 1 $nline); do
  781. AUTHORIZED_KEYS_OPTIONS="${koptions[$i]}" FILE_TYPE='authorized_keys' process_keys_for_file "$authorizedKeys" "${userIDs[$i]}" || returnCode="$?"
  782. done
  783. }
  784. # takes a gpg key or keys on stdin, and outputs a list of
  785. # fingerprints, one per line:
  786. list_primary_fingerprints() {
  787. local fake=$(msmktempdir)
  788. trap "rm -rf $fake" EXIT
  789. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  790. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  791. awk -F: '/^fpr:/{ print $10 }'
  792. trap - EXIT
  793. rm -rf "$fake"
  794. }
  795. # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
  796. # key identifier as $1, and outputs the gpg-formatted information for
  797. # the requested keys from the material on stdin
  798. get_cert_info() {
  799. local fake=$(msmktempdir)
  800. trap "rm -rf $fake" EXIT
  801. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  802. GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
  803. trap - EXIT
  804. rm -rf "$fake"
  805. }
  806. check_cruft_file() {
  807. local loc="$1"
  808. local version="$2"
  809. if [ -e "$loc" ] ; then
  810. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  811. fi
  812. }
  813. check_upgrade_dir() {
  814. local loc="$1"
  815. local version="$2"
  816. if [ -d "$loc" ] ; then
  817. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  818. fi
  819. }
  820. ## look for cruft from old versions of the monkeysphere, and notice if
  821. ## upgrades have not been run:
  822. report_cruft() {
  823. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  824. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  825. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  826. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  827. local found=
  828. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  829. if [ -d "$foo" ] ; then
  830. printf "! %s\n" "$foo" | log info
  831. found=true
  832. fi
  833. done
  834. if [ "$found" ] ; then
  835. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  836. fi
  837. }